/* Example program (compile with "ppwizard BASEDATE.X /rexx") */

/*--- Load required headers -------------------------------------------------*/
#define  INCL_FileBaseDate
#define  INCL_BD2DATE                          ;;Want to be able
#define  INCL_BD2DATE_YYMMDD                   ;;Want this extra format
#define  INCL_Day4BaseDate
#include "BaseDate.XH"
;#include "AddComma.XH"

/*--- Show rexx date --------------------------------------------------------*/
say 'DATE("B")       = ' || AddCommasToDecimalNumber( date('B') );

/*--- Try routine 3 ---------------------------------------------------------*/
say '';
say 'BaseDate(?)'
say '~~~~~~~~~~~';
say '""              = ' || AddCommasToDecimalNumber( BaseDate() );
say '"98 004 000028" = ' || AddCommasToDecimalNumber( BaseDate("98 004 000028") );
say '"19980428"      = ' || AddCommasToDecimalNumber( BaseDate("19980428") );
say '"1998/04/28"    = ' || AddCommasToDecimalNumber( BaseDate("1998/04/28") );
say '';
say 'BaseDate(?) with Invalid Dates'
say '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~';
say '"asdf/04/28"    = ' || AddCommasToDecimalNumber( BaseDate("asdf/04/28") );
say '"1998/04/31"    = ' || AddCommasToDecimalNumber( BaseDate("1998/04/31") );

/*--- Get file basedates ----------------------------------------------------*/
say '';
say 'FileBaseDate(?)';
say '~~~~~~~~~~~~~~~';
say '"C:\CONFIG.SYS"   = ' || AddCommasToDecimalNumber( FileBaseDate("C:\CONFIG.SYS"  ) ) || '  (' || DATE("B") - FileBaseDate("C:\CONFIG.SYS"  ) || ' days old).';
say '"C:\AUTOEXEC.BAT" = ' || AddCommasToDecimalNumber( FileBaseDate("C:\AUTOEXEC.BAT") );
say '"C:\NOSUCH.FIL"   = ' || AddCommasToDecimalNumber( FileBaseDate("C:\NOSUCH.FIL"  ) );

/*--- Relative Dates --------------------------------------------------------*/
say '';
TodaysBaseDate = BaseDate();
say 'Calculate Relative Dates'
say '~~~~~~~~~~~~~~~~~~~~~~~~';
say 'YesterDay = ' || Bd2Date(TodaysBaseDate-1,,        '/');
say 'Today-YY  = ' || Bd2Date(TodaysBaseDate, 'YYMMDD', '/') || ' - ' || Day4BaseDate(TodaysBaseDate);
say 'Tomorrow  = ' || Bd2Date(TodaysBaseDate+1,,        '/');
say '-999 days = ' || Bd2Date(TodaysBaseDate-999,,      '-');
say '+999 days = ' || Bd2Date(TodaysBaseDate+999,,      '-');

exit(255);





/*===========================================================================*/
AddCommasToDecimalNumber: procedure       /* Here so don't need AddComma.XH" */
/*===========================================================================*/
   /*--- Get number return it it we already have commas ---------------------*/
   NoComma = strip( arg(1) );
   if  pos(',', NoComma) <> 0 then
       return(NoComma);

   /*--- split at possible decimal point ------------------------------------*/
   DotPos = pos('.', NoComma);
   if  DotPos = 0 then
       AfterDecimal = '';
   else
   do
       /*--- There is a decimal component -----------------------------------*/
       if  DotPos = 1 then
           return("0" || NoComma);
       AfterDecimal = substr(NoComma, DotPos+1);
       NoComma      = left(NoComma, DotPos-1);
   end;

   /*--- Reverse the integer ------------------------------------------------*/
   NoComma = reverse(NoComma);

   /*--- Grab 3 digits at a time --------------------------------------------*/
   ResultWithCommas = "";
   do  while length(NoComma) > 3
       ResultWithCommas = ResultWithCommas || left(NoComma, 3) || ',';
       NoComma          = substr(NoComma, 4);
   end;
   ResultWithCommas = ResultWithCommas || NoComma;

   /*--- Reverse the string and add decimal component -----------------------*/
   ResultWithCommas = reverse(ResultWithCommas)
   if  AfterDecimal <> '' then
       ResultWithCommas = ResultWithCommas || '.' || AfterDecimal;
   return(ResultWithCommas);
